import Vue from 'vue';
import VueRouter from 'vue-router';
import VueCookies from 'vue-cookies';
//import Login from './components/Login.vue';
import App from './components/App.vue';
import { routes } from './routes';
//import moment from 'moment';


Vue.use(VueRouter);
Vue.use(VueCookies);

const router = new VueRouter({
    routes,
    base: __dirname,
    /*mode: 'history',
    //base: import.meta.env.BASE_URL,
    //base: process.env.BASE_URL,
    scrollBehavior(to, from, savedPosition) {
      return {x: 0, y: 0};
    }*/
});



// Register service worker.
if ('serviceWorker' in navigator) {
  window.addEventListener('load', () => {
    navigator.serviceWorker.register('./service-worker.js')
        .then((reg) => {
          console.log('Service worker registered.', reg);
        });
  });
} 

// Configuramos cookies a 7 días
Vue.$cookies.config('7d');

// formato de fechas
Vue.filter('formatDate', function(value) {
  if (value) {
    return moment(String(value)).format('MM/DD/YYYY hh:mm')
  }
});

Vue.prototype.$header =  new Headers({
  'Authorization': `Bearer ${localStorage.getItem('token')}`,
  'Accept': 'application/json',
  'Content-type': 'application/json'
});


// create a directive to transform the model value
Vue.directive("uppercase", {
  twoWay: true,
  // TODO: unbind
  unbind: () => {},
  bind: function (el, binding, vnode) {
    const findVModelName = vnode => {
      try {
        // https://forum.vuejs.org/t/solved-how-can-you-update-the-v-model-from-a-custom-directive-in-vue-2/2275
        return vnode.data.directives.find(o => {
          return o.name === "model";
        }).expression;
      } catch (error) {
        error.message = `Unable to find v-model directive at ${
          vnode.tag
        } tag. Please specify the expression: v-uppercase='obj.prop'`;
        throw error;
      }
    };

    const funcByName = (functionName, context, value) => {
      // https://stackoverflow.com/a/359910/8801075
      var namespaces = functionName.split(".");
      var func = namespaces.pop();
      for (var i = 0; i < namespaces.length; i++)
        context = context[namespaces[i]];
      return (context[func] = value);
    };

    var expression = binding.expression ?
      binding.expression :
      findVModelName(vnode);
    vnode.context.$watch(expression, {
      //deep: true, // ?
      immediate: true,
      handler(newVal) {
        if (newVal) {
          return funcByName(
            expression,
            vnode.context,
            newVal.toString().toLocaleUpperCase()
          );
        }
      }
    });
  }
});


/*new Vue({
    render: h => h(Login)
}).$mount('#app');*/
var app = new Vue({
    el: '#app',  
    router,    
    render: h => h(App)
});