import App from './components/App.vue';
import Organizacion from './components/Organizacion.vue';
import Login from './components/Login.vue';
import Empleado from './components/Empleado.vue';
import RegistroHorario from './components/RegistroHorario.vue';
import Convenio from './components/Convenio.vue';
import CentroTrabajo from './components/CentroTrabajo.vue';
import Departamento from './components/Departamento.vue';
import Turno from './components/Turno.vue';
import TipoContrato from './components/TipoContrato.vue';
import Calendario from './components/Calendario.vue';
import Evento from './components/Evento.vue';
import Informe from './components/Informe.vue';
import ContratoEmpleado from './components/ContratoEmpleado.vue';
import Jornada from './components/Jornada.vue';
import Menu from './components/layout/Menu.vue';
import Faqs from './components/Faqs.vue';
import PageNotFound from './components/PageNotFound.vue';
import Aviso from './components/Aviso.vue';

export const routes = [
    {   path: '/', 
        abstract: true, 
        component: Login, 
        meta: {
            plainLayout: true,
        }
    },
    { path: '/app', component: App },
    { path: '/organizacion', name: 'organizacion', component: Organizacion },
    { path: '/empleado', name: 'empleado', component: Empleado },
    { path: '/empleado/:id', name: 'empleado/id', component: Empleado },
    { path: '/centrotrabajo', name: 'centrotrabajo', component: CentroTrabajo },
    { path: '/centrotrabajo/:id', name: 'centrotrabajo/id', component: CentroTrabajo },
    { path: '/departamento', name: 'departamento', component: Departamento },
    { path: '/departamento/:id', name: 'departamento/id', component: Departamento },    
    { path: '/convenio', name: 'convenio', component: Convenio  },
    { path: '/convenio/:id', name: 'convenio/id', component: Convenio  },
    { path: '/turno', name: 'turno', component: Turno },
    { path: '/turno/:id', name: 'turno/id', component: Turno },
    { path: '/tipocontrato', name: 'tipocontrato',  component: TipoContrato },
    { path: '/tipocontrato/:id', name: 'tipocontrato/id',  component: TipoContrato },
    { path: '/evento', name: 'evento', component: Evento },
    { path: '/evento/:id', name: 'evento/id', component: Evento },
    { path: '/registrohorario', name: 'registrohorario', component: RegistroHorario },
    { path: '/calendario', name: 'calendario', component: Calendario },
    { path: '/informe', name: 'informe', component: Informe },
    { path: '/informe/:tipo', name: 'informe/tipo', component: Informe },
    { path: '/contratoempleado', name: 'contratoempleado', component: ContratoEmpleado },
    { path: '/contratoempleado/:id', name: 'contratoempleado/id', component: ContratoEmpleado },
    { path: '/jornada', name: 'jornada', component: Jornada },
    { path: '/jornada/:id', name: 'jornada/id', component: Jornada },
    { path: '/aviso', name: 'aviso', component: Aviso },
    { path: '/faqs', name: 'faqs', component: Faqs},
    { path: '/menu', name: 'menu', component: Menu },
    { path: '/logout', name: 'logout', component: Login, meta: {plainLayout: true}},
    //{ path: '/offline', name: 'offline', component: Offline, meta: {plainLayout: true}},
    { 
        path: '*', 
        component: PageNotFound,
        meta: {
            plainLayout: true,
        }
    }
];