const express = require('express');
const morgan = require('morgan');
const path = require('path');
const config = require('./config');
const auth = require('./middlewares/auth');
//const { Pool, Client } = require('pg')

const app = express();


// Connection BD
/*const client = new Client({
    user: 'prbnnoeimelclv',
    host: 'ec2-52-21-153-207.compute-1.amazonaws.com',
    database: 'd12ll3vokbc54e',
    password: 'cd6fbd126316451006956166d79a2dc9da5cef13d023f3cc9631dab14d829fc0',
    port: 5432,
    ssl: {
        require: true, // This will help you. But you will see nwe error
        rejectUnauthorized: false // This line will fix new error
    }
});

client.connect()
    .then(db => console.log('DB is connected'))
    .catch(err => console.error(err));
*/

// Settings (Configuraciones)
app.set('port', config.port);          // puerto definido por el servidor o el 3000

// Middlewares (funciones que se ejecutan antes de recibir peticiones)
app.use(morgan('dev'));
app.use(express.json({limit: '10mb', extended: true}));
app.use(express.urlencoded({limit: '10mb', extended: true}));



// Routes (rutas)
app.use('/api/usuarios', require('./routes/usuarios'));
app.use('/api/organizaciones', require('./routes/organizaciones'));
app.use('/api/empleados', auth, require('./routes/empleados'));
app.use('/api/eventos', auth, require('./routes/eventos'));
app.use('/api/registroshorarios', auth, require('./routes/registroshorarios'));
app.use('/api/festivos', auth, require('./routes/festivos'));
app.use('/api/ausencias', auth, require('./routes/ausencias'));
app.use('/api/personales', auth, require('./routes/personales'));
app.use('/api/centrostrabajo', auth, require('./routes/centrostrabajo'));
app.use('/api/convenios', auth, require('./routes/convenios'));
app.use('/api/turnos', auth, require('./routes/turnos'));
app.use('/api/rolesusuario', auth, require('./routes/rolesusuario'));
app.use('/api/departamentos', auth, require('./routes/departamentos'));
app.use('/api/tiposcontrato', auth, require('./routes/tiposcontrato'));
app.use('/api/contratosempleado', auth, require('./routes/contratosempleado'));
app.use('/api/jornadas', auth, require('./routes/jornadas'));
app.use('/api/avisos', auth, require('./routes/avisos'));



const history = require('connect-history-api-fallback');
app.use(history());
// Static files (archivos al frontend)
app.use(express.static(__dirname + '/public'));                  // definimos la carpeta public

/*
app.all('/departamento', function(req, res) {
    console.log('Hola', req);
});
app.get('/', (req,res) => {
    console.log('Accessing the secret section ...');
    res.sendFile(path.join(__dirname, '/public/index.html'));
});
app.all('/', function (req, res, next) {
    console.log('Accessing the secret section ...');
    next();
});
*/

app.get('/logout', function(req, res) {
    res.redirect('/');
})



// Servidor está escuchando
app.listen(app.get('port'), () => {
    console.log(`Servidor activo en puerto ${app.get('port')}`);
});