const express = require('express');
const router = express.Router();  // Objeto para definir rutas

// Conexión con PostgreSQL
const pool = require('./database/pool');

// GET all
router.get('/', (request, response) => {   
    //request.query.idempleado; 
    console.log('request.user', request.user);    
    pool.query('SELECT * FROM laboreo_pwa.f_centrotrabajo($1) ORDER BY codigo ASC', [request.user], (error, results) => {
        if (error) {
            //throw error
            response.status(500).send(error);
        }
        response.status(200).json(results.rows)
    });
});
  
// GET id
router.get('/:id', (request, response) => {
    const {id} = request.params;
    pool.query('SELECT * FROM laboreo_pwa.f_centrotrabajo($2) WHERE (idcentrotrabajo = $1) OR $2 = 0', [id, request.user], (error, results) => {
            if (error) {
                //throw error
                response.status(500).send(error);
            }
            response.status(200).json(results.rows)
    });
});

// GET id
router.get('/:id/departamentos', (request, response) => {    
    const {id} = request.params;
    console.log(`SELECT * FROM laboreo_pwa.f_departamento WHERE idcentrotrabajo = ${id} AND idempleadoacceso = ${request.user}`)
    pool.query('SELECT * FROM laboreo_pwa.f_departamento($2) WHERE (idcentrotrabajo = $1) OR $2 = 0', [id, request.user], (error, results) => {
            if (error) {
                //throw error
                response.status(500).send(error);
            }
            response.status(200).json(results.rows)
    });
});

// GET id
router.get('/:id/empleados', (request, response) => {    
    const {id} = request.params;
    pool.query('SELECT * FROM laboreo_pwa.f_empleado($2) WHERE (idcentrotrabajo = $1) OR $2 = 0', [id, request.user], (error, results) => {
            if (error) {
                //throw error
                response.status(500).send(error);
            }
            response.status(200).json(results.rows)
    });
});


// PUT modificación
router.put('/:id', (request, response) => {
    const {id} = request.params;
    const { codigo, nombre, direccion, codigopostal, poblacion, pais, telefono } = request.body;
    if (codigo && nombre ) {
        pool.query('UPDATE laboreo_pwa.centrotrabajo SET codigo = $1, nombre = $2, direccion  = $3, codigopostal = $4, poblacion = $5, pais = $6, telefono = $7 WHERE idcentrotrabajo = $8;', [codigo, nombre, direccion, codigopostal, poblacion, pais, telefono, id], (error, results) => {
        if (error) {
            //throw error
            response.status(500).send(error);
        }
        response.status(200).send(`Registro horario modificado con el ID: ${id}`)
        });             
    } else {
        response.status(500).json({error: 'Ha ocurrido un error'});
    }
});
// PATCH
router.patch('/:id', (request, response) => {
    const {id} = request.params;
    const { codigo, nombre, direccion, codigopostal, poblacion, pais, telefono } = request.body;
    if (codigo && nombre ) {
        pool.query('UPDATE laboreo_pwa.centrotrabajo SET codigo = $1, nombre = $2, direccion  = $3, codigopostal = $4, poblacion = $5, pais = $6, telefono = $7 WHERE idcentrotrabajo = $8;', [codigo, nombre, direccion, codigopostal, poblacion, pais, telefono, id], (error, results) => {
        if (error) {
            //throw error
            response.status(500).send(error);
        }
        response.status(200).send(`Registro horario modificado con el ID: ${idevento}`)
        });             
    } else {
        response.status(500).json({error: 'Ha ocurrido un error'});
    }
});

// POST insertar
router.post('/', (request, response) => {
    const { codigo, nombre, direccion, codigopostal, poblacion, pais, telefono, idorganizacion } = request.body;
    //console.log(request.body);    
    console.log(`INSERT INTO laboreo_pwa.centrotrabajo (codigo, nombre, direccion, codigopostal, poblacion, pais, telefono, idorganizacion) VALUES (${codigo}, ${nombre}, ${direccion}, ${codigopostal}, ${poblacion}, ${pais}, ${telefono}, ${idorganizacion});`);
    if (codigo && nombre && direccion && idorganizacion) {
        pool.query('INSERT INTO laboreo_pwa.centrotrabajo (codigo, nombre, direccion, codigopostal, poblacion, pais, telefono, idorganizacion) VALUES ($1, $2, $3, $4, $5, $6, $7, $8);', [codigo, nombre, direccion, codigopostal, poblacion, pais, telefono, idorganizacion], (error, results) => {
        if (error) {         
            response.status(500).send(error);
            //throw error;
        }
        //response.status(201).send(`User added with ID: ${results.insertId}`);
        response.status(201).json({status: 'Registrado'});
        });           

    } else {     
        response.status(500).json({error: 'Ha ocurrido un error'});
    }
});


router.delete('/:id', (request, response) => {
    const {id} = request.params;
    pool.query('DELETE FROM laboreo_pwa.centrotrabajo WHERE idcentrotrabajo = $1', [id], (error, results) => {
        if (error) {
            response.status(500).send(error);      
        }
        response.status(200).send(`Registro horario eliminado con ID: ${id}`)
    })
});

module.exports = router;