const express = require('express');
const router = express.Router();  // Objeto para definir rutas

// Conexión con PostgreSQL
const pool = require('./database/pool');

// GET all
router.get('/', (request, response) => {
    console.log(`SELECT * FROM laboreo_pwa.f_departamento(${request.user}) ORDER BY codigo ASC`)
    pool.query('SELECT * FROM laboreo_pwa.f_departamento($1) ORDER BY codigo ASC', [request.user], (error, results) => {
        if (error) {
            //throw error
            response.status(500).send(error);
        }
        response.status(200).json(results.rows)
    });
});
  
// GET id
router.get('/:id', (request, response) => {
    const {id} = request.params;
    pool.query('SELECT * FROM laboreo_pwa.f_departamento($2) WHERE iddepartamento = $1', [id, request.user], (error, results) => {
            if (error) {
                //throw error
                response.status(500).send(error);
            }
            response.status(200).json(results.rows)
    });
});

// GET id
router.get('/:id/empleados', (request, response) => {
    const {id} = request.params;
    pool.query('SELECT * FROM laboreo_pwa.f_empleado($2) WHERE iddepartamento = $1', [id, request.user], (error, results) => {
            if (error) {
                //throw error
                response.status(500).send(error);
            }
            response.status(200).json(results.rows)
    });
});


// PUT modificación
router.put('/:id', (request, response) => {
    const {id} = request.params;
    const { codigo, nombre, idcentrotrabajo, idempleado_responsable } = request.body;
    if (codigo && nombre && idcentrotrabajo) {
        pool.query('UPDATE laboreo_pwa.departamento SET codigo = $1, nombre = $2, idcentrotrabajo = $3, idempleado_responsable = $4 WHERE iddepartamento = $5;', [codigo, nombre, idcentrotrabajo, idempleado_responsable, id], (error, results) => {
        if (error) {
            //throw error
            response.status(500).send(error);
        }
        response.status(200).send(`Registro horario modificado con el ID: ${id}`)
        });             
    } else {
        response.status(500).json({error: 'Ha ocurrido un error'});
    }
});
// PATCH
router.patch('/:id', (request, response) => {
    const {id} = request.params;
    const { codigo, nombre, idcentrotrabajo, idempleado_responsable } = request.body;
    if (codigo && nombre && idcentrotrabajo) {
        pool.query('UPDATE laboreo_pwa.departamento SET codigo = $1, nombre = $2, idcentrotrabajo = $3, idempleado_responsable = $4 WHERE iddepartamento = $5;', [codigo, nombre, idcentrotrabajo, idempleado_responsable, id], (error, results) => {
        if (error) {
            //throw error
            response.status(500).send(error);
        }
        response.status(200).send(`Registro horario modificado con el ID: ${idevento}`)
        });             
    } else {
        response.status(500).json({error: 'Ha ocurrido un error'});
    }
});

// POST insertar
router.post('/', (request, response) => {
    const { codigo, nombre, idcentrotrabajo, idempleado_responsable } = request.body;
//    console.log(request.body);    
//    console.log(`INSERT INTO laboreo_pwa.departamento (idempleado, fechainicio, fechafin, entrada, longitud, latitud, fecharegistro) VALUES (${idempleado}, ${fechainicio}, ${fechafin}, ${entrada}, ${longitud}, ${latitud});`);
    if (codigo && nombre && idcentrotrabajo ) {
        pool.query('INSERT INTO laboreo_pwa.departamento (codigo, nombre, idcentrotrabajo, idempleado_responsable) VALUES ($1, $2, $3, $4);', [codigo, nombre, idcentrotrabajo, idempleado_responsable], (error, results) => {
        if (error) {         
            response.status(500).send(error);
            //throw error;
        }
        //response.status(201).send(`User added with ID: ${results.insertId}`);
        response.status(201).json({status: 'Registrado'});
        });           

    } else {     
        response.status(500).json({error: 'Ha ocurrido un error'});
    }
});


router.delete('/:id', (request, response) => {
    const {id} = request.params;
    pool.query('DELETE FROM laboreo_pwa.departamento WHERE iddepartamento = $1', [id], (error, results) => {
        if (error) {
            response.status(500).send(error);      
        }
        response.status(200).send(`Registro horario eliminado con ID: ${id}`)
    })
});

module.exports = router;