const express = require('express');
const router = express.Router();  // Objeto para definir rutas

// Conexión con PostgreSQL
const pool = require('./database/pool');

// GET all
router.get('/', (request, response) => {
    pool.query('SELECT * FROM laboreo_pwa.registrohorario INNER JOIN laboreo_pwa.evento ON evento.idevento = registrohorario.idevento ORDER BY fechainicio ASC', (error, results) => {
        if (error) {
            //throw error
            response.status(500).send(error);
        }
        response.status(200).json(results.rows)
    });
});
  
// GET id
router.get('/:id', (request, response) => {
    const {id} = request.params;
    pool.query('SELECT * FROM laboreo_pwa.registrohorario WHERE idevento = $1', [id], (error, results) => {
            if (error) {
            //throw error
            response.status(500).send(error);
            }
            response.status(200).json(results.rows)
    });
});


// PUT modificación
router.put('/:id', (request, response) => {
    const {id} = request.params;
    const { fechainicio, fechafin, entrada } = request.body;
    console.log(`UPDATE laboreo_pwa.registrohorario SET fechainicio = ${fechainicio}, fechafin = ${fechafin}, entrada  = ${entrada} WHERE idevento = ${id};`)
    if (fechainicio && fechafin) {
        pool.query('UPDATE laboreo_pwa.registrohorario SET fechainicio = $1, fechafin = $2, entrada  = $3 WHERE idevento = $4;', [fechainicio, fechafin, entrada, id], (error, results) => {
        if (error) {
            //throw error
            response.status(500).send(error);
        }
        response.status(200).send(`Registro horario modificado con el ID: ${id}`)
        });             
    } else {
        response.status(500).json({error: 'Ha ocurrido un error'});
    }
});
// PATCH
router.patch('/:id', (request, response) => {
    const {id} = request.params;
    const { fechainicio, fechafin, entrada } = request.body;
    if (fechainicio && fechafin ) {
        pool.query('UPDATE laboreo_pwa.registrohorario SET fechainicio = $1, fechafin = $2, entrada  = $3 WHERE idevento = $4;', [fechainicio, fechafin, entrada, id], (error, results) => {
        if (error) {
            //throw error
            response.status(500).send(error);
        }
        response.status(200).send(`Registro horario modificado con el ID: ${idevento}`)
        });             
    } else {
        response.status(500).json({error: 'Ha ocurrido un error'});
    }
});

// POST insertar
router.post('/', (request, response) => {
    const { idempleado, fechainicio, fechafin, entrada, longitud, latitud } = request.body;
//    console.log(request.body);    
//    console.log(`INSERT INTO laboreo_pwa.registrohorario (idempleado, fechainicio, fechafin, entrada, longitud, latitud, fecharegistro) VALUES (${idempleado}, ${fechainicio}, ${fechafin}, ${entrada}, ${longitud}, ${latitud});`);
    if (idempleado && fechainicio && fechafin && entrada) {
        pool.query('INSERT INTO laboreo_pwa.registrohorario (idempleado, fechainicio, fechafin, entrada, longitud, latitud, fecharegistro) VALUES ($1, $2, $3, $4, $5, $6, NOW() AT TIME ZONE \'Europe/Paris\');', [idempleado, fechainicio, fechafin, entrada, longitud, latitud], (error, results) => {
        if (error) {         
            response.status(500).send(error);
            //throw error;
        }
        //response.status(201).send(`User added with ID: ${results.insertId}`);
        response.status(201).json({statustext: 'Registro insertado correctamente'});
        });           

    } else {     
        response.status(500).json({error: 'Ha ocurrido un error'});
    }
});


router.delete('/:id', (request, response) => {
    const {id} = request.params;
    pool.query('DELETE FROM laboreo_pwa.registrohorario WHERE idevento = $1', [id], (error, results) => {
        if (error) {
            response.status(500).send(error);      
        }
        response.status(200).send(`Registro horario eliminado con ID: ${id}`)
    })
});

module.exports = router;