const jwt = require('jwt-simple');
const moment = require('moment')
const config = require('../../config')

// Crear Token
function createToken(user) {
    const payload = {
        sub: user.idempleado,
        iat: moment().unix(),   // cuando fue creado el token
        exp: moment().add(14, 'days').unix(),   // cuando expira el token
    }

    console.log('DNI', user.dni);

    return jwt.encode(payload, config.SECRET_TOKEN)
}

// Decodificar Token
function decodeToken (token) {
    const decoded = new Promise((resolve, reject) => {
        try {
            const payload = jwt.decode(token, config.SECRET_TOKEN)

            if (payload.exp <= moment().unix()){
                reject({
                    status: 401,
                    message: 'Token ha caducado'
                })
            }            
            // Token correcto
            resolve(payload.sub);
        } catch (err) {
            reject({
                status: 500,
                message: 'Invalid Token'
            })
        }
    })

    return decoded
}

module.exports = {createToken, decodeToken}