const express = require('express');
const router = express.Router();  // Objeto para definir rutas

// Conexión con PostgreSQL
const pool = require('./database/pool');

// GET all
router.get('/', (request, response) => {
    pool.query('SELECT * FROM laboreo_pwa.turno ORDER BY codigo ASC', (error, results) => {
        if (error) {
            //throw error
            response.status(500).send(error);
        }
        response.status(200).json(results.rows)
    });
});
  
// GET id
router.get('/:id', (request, response) => {
    const {id} = request.params;
    pool.query('SELECT * FROM laboreo_pwa.turno WHERE idturno = $1', [id], (error, results) => {
            if (error) {
                //throw error
                response.status(500).send(error);
            }
            response.status(200).json(results.rows)
    });
});


// PUT modificación
router.put('/:id', (request, response) => {
    const {id} = request.params;
    const { codigo, nombre, lunes, martes, miercoles, jueves, viernes, sabado, domingo, horainicio, horafin, idorganizacion } = request.body;
    if (codigo && nombre && horainicio && horafin ) {
        pool.query('UPDATE laboreo_pwa.turno SET codigo = $1, nombre = $2, lunes  = $3, martes = $4, miercoles = $5, jueves = $6, viernes = $7, sabado = $8, domingo = $9, horainicio = $10, horafin = $11 WHERE idturno = $12;', [codigo, nombre, lunes, martes, miercoles, jueves, viernes, sabado, domingo, horainicio, horafin, id], (error, results) => {
        if (error) {
            //throw error
            response.status(500).send(error);
        }
        response.status(200).send(`Registro horario modificado con el ID: ${id}`)
        });             
    } else {
        response.status(500).json({error: 'Ha ocurrido un error'});
    }
});
// PATCH
router.patch('/:id', (request, response) => {
    const {id} = request.params;
    const { codigo, nombre, lunes, martes, miercoles, jueves, viernes, sabado, domingo, horainicio, horafin, idorganizacion } = request.body;
    if (codigo && nombre && horainicio && horafin) {
        pool.query('UPDATE laboreo_pwa.turno SET codigo = $1, nombre = $2, lunes  = $3, martes = $4, miercoles = $5, jueves = $6, viernes = $7, sabado = $8, domingo = $9, horainicio = $10, horafin = $11 WHERE idturno = $12;', [codigo, nombre, lunes, martes, miercoles, jueves, viernes, sabado, domingo, horainicio, horafin, id], (error, results) => {
        if (error) {
            //throw error
            response.status(500).send(error);
        }
        response.status(200).send(`Registro horario modificado con el ID: ${idevento}`)
        });             
    } else {
        response.status(500).json({error: 'Ha ocurrido un error'});
    }
});

// POST insertar
router.post('/', (request, response) => {
    const { codigo, nombre, lunes, martes, miercoles, jueves, viernes, sabado, domingo, horainicio, horafin, idorganizacion } = request.body;
//    console.log(request.body);    
//    console.log(`INSERT INTO laboreo_pwa.turno (idempleado, fechainicio, fechafin, entrada, longitud, latitud, fecharegistro) VALUES (${idempleado}, ${fechainicio}, ${fechafin}, ${entrada}, ${longitud}, ${latitud});`);
    if (codigo && nombre && horainicio && horafin) {
        pool.query('INSERT INTO laboreo_pwa.turno (codigo, nombre, lunes, martes, miercoles, jueves, viernes, sabado, domingo, horainicio, horafin, idorganizacion) VALUES ($1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12);', [codigo, nombre, lunes, martes, miercoles, jueves, viernes, sabado, domingo, horainicio, horafin, idorganizacion], (error, results) => {
        if (error) {         
            response.status(500).send(error);
            //throw error;
        }
        //response.status(201).send(`User added with ID: ${results.insertId}`);
        response.status(201).json({status: 'Registrado'});
        });           

    } else {     
        response.status(500).json({error: 'Ha ocurrido un error'});
    }
});


router.delete('/:id', (request, response) => {
    const {id} = request.params;
    pool.query('DELETE FROM laboreo_pwa.turno WHERE idturno = $1', [id], (error, results) => {
        if (error) {
            response.status(500).send(error);      
        }
        response.status(200).send(`Registro horario eliminado con ID: ${id}`)
    })
});

module.exports = router;