const { VueLoaderPlugin } = require('vue-loader');
const HTMLWebpackPlugin = require('html-webpack-plugin');
const path = require('path');

const indextInput = './src/public/index.html';
const indexOutput = 'index.html';

module.exports = {
    entry: ['@babel/polyfill', './src/app/index.js'],
    //entry: './src/index.js',
    output: {
        path:  path.join(__dirname, '/src/public/js'),
        //publicPath: process.env.NODE_ENV === 'production' ? '/~irosillo/AIM/pacs/pr/dist/' : '/dist/',
        filename: 'bundle.js'
    },
    module: {
        rules: [
            {
                test: /\.js$/,
                exclude: /node_modules/,
                use: {
                    loader: 'babel-loader'
                }
            },
            {
                test: /\.vue$/,
                loader: 'vue-loader'
            },
            {
                test: /.css$/,
                use: [
                  'vue-style-loader',
                  'css-loader',
                ]
            }
        ]
    },
    plugins: [        
        /*new webpack.DefinePlugin({
            'process.env': {
              NODE_ENV: '"production"',
              BASE_URL: JSON.stringify('/')
            }
        }),*/
        new VueLoaderPlugin(),
        new HTMLWebpackPlugin({
            filename: indexOutput, 
            template: indextInput,
        })
    ]
};